<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">
<!-- 
    File         : preflight.xsl
    
    Author       : Leonard Rosenthol
    						  Based on code from Lawrence E. Freil

    Date Created : may 7, 2004

    Description  : This file is an XSL stylesheet used as a demonstration
                   for pdfgetAttrs.  It will output a short HTML
		   				  report of all the images used in the file.
    Copywrite(C) - 2004 Apago Inc.
-->

<!-- Text gobbler! -->
<xsl:template match='text()'>
</xsl:template>

<xsl:template match='/'>
  <!-- If the user specified default styles in the view file, then
       we will use those styles and hope he set them up nicely.
       Otherwise we will default to our own style here.
  -->
  <HTML>
  <HEAD>
  <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  </META>
  <TITLE><xsl:value-of select="pdfattrs/@path"/></TITLE>
  <!-- Output the needed javascript -->
  <SCRIPT LANGUAGE="JavaScript">
<![CDATA[
<!--
var bV=parseInt(navigator.appVersion);
NS4=(document.layers) ? true : false;
IE4=((document.all)&&(bV>=4))?true:false;

ver4 = (NS4 || IE4) ? 1 : 0;
function donothing() { return }

// Create the image pre-load array, then let the body pre-load images.
ButtonArray = new Array();
fixButtonArray = new Array();

function preload(imName) {
  ButtonArray[imName + "Up"] = new Image();
  ButtonArray[imName + "Up"].src = imName + "Up.gif";
  ButtonArray[imName + "Over"] = new Image();
  ButtonArray[imName + "Over"].src = imName + "Over.gif";
  ButtonArray[imName + "Down"] = new Image();
  ButtonArray[imName + "Down"].src = imName + "Down.gif";
}

function rollOver(imName,over,imBase) {
  if (over) { document.images[imName].src = ButtonArray[imBase + "Over"].src }
    else { document.images[imName].src = ButtonArray[imBase + "Up"].src }
}

function rollPress(imName,down,imBase) {
  if (down) { document.images[imName].src = ButtonArray[imBase + "Down"].src }
    else { document.images[imName].src = ButtonArray[imBase + "Over"].src }
}

function loadbtns() {
  preload("BTNdelete");
  preload("BTNdownload");
  preload("BTNconvert");
  preload("BTNproof");
  //alert("All buttons used are now pre-loaded");
}
// -->
]]>
  </SCRIPT>
  </HEAD>
  <BODY TEXT="#000000" BGCOLOR="#ffffcc" OnLoad="loadbtns()"> 
  <P ALIGN="CENTER"><IMG SRC="http://www.apago.com/images/3nav2.jpg" alt="3nav2.jpg (15249 bytes)" WIDTH="563" HEIGHT="69"/></P>
  <CENTER>
  <H1>Preflight Report</H1>
  <H3>for</H3>
  <H2><xsl:value-of select="pdfattrs/@path"/></H2>
  </CENTER>

  <STYLE TYPE="text/css">
        DIV.title { background-color:teal; color:white; 
                     font-family:Verdana,arial; font-size:14pt; 
                     padding:2px;
                  }
        DIV.asset { background-color:black; color:white; 
                    font-family:Verdana,arial; font-size:14pt; 
                    padding:2px;
                  }
        A.titlelink { color:aqua; }
        DIV.body { background-color:#ffffcc; color:Black; 
                   padding:2px;
                   font-size:11pt;
                 }
        <!-- The following turns off underlines over links -->
        A { text-decoration: none; }
        A:hover { color:red }
  </STYLE>
  <xsl:apply-templates />
  </BODY>
  </HTML>
</xsl:template>

<xsl:template match="pdfattrs">
	<tr><h3>Document Info</h3></tr>
	<table border="0" cols="2" width="600" >
		<tr><td><b>PDF Version: </b></td><td><xsl:value-of select="./@version"/></td></tr>
		<xsl:if test="./info/GTS_PDFXVersion!=''">
			<tr><td style="font-weight:bold;color='green'">PDF/X Version: </td><td style="color='green'"><xsl:value-of select="./info/GTS_PDFXVersion"/></td></tr>
			<tr><td style="font-weight:bold;color='green'">PDF/X OutputIntent: </td><td style="color='green'"><xsl:value-of select="./OutputIntents/v0/@OutputConditionIdentifier"/></td></tr>
			<tr><td style="font-weight:bold;color='green'">Trapped: </td><td style="color='green'"><xsl:value-of select="./info/Trapped"/></td></tr>
		</xsl:if>
		<tr><td><b>Page Count: </b></td><td><xsl:value-of select="count(./page)"/></td></tr>
		<tr><td width="200"><b>Fast Web View Enabled: </b></td><td><xsl:value-of select="./@linearized"/></td></tr>
		<tr><td><b>Encrypted: </b></td><td><xsl:value-of select="./@encrypted"/></td></tr>
		<tr><td><b>Tagged: </b></td><td><xsl:value-of select="./@tagged"/></td></tr>
		<tr><td><b>XMP metadata: </b></td><td><xsl:value-of select="./metadata!=''"/></td></tr>
		<tr>
			<td><b>Filesize: </b></td>
			<xsl:variable name="fsize" select="./@filesize"/>
			<xsl:choose>
				<xsl:when test="1024 > $fsize">
					<td><xsl:value-of select="$fsize"/> bytes</td>
				</xsl:when>
				<xsl:when test="$fsize > 1048576"> <!-- 1 meg -->
					<td><xsl:value-of select="round($fsize div 1048576)"/> MB</td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="round($fsize div 1024)"/> KB</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<tr></tr>
	</table>
	<p/>
	
	<!-- colors & fonts -->
	<xsl:apply-templates select="colors" />
	<xsl:apply-templates select="fonts" />
	<p/>
	
	<!-- Document Level elements -->
	<table cols="2" width="300">
		<tbody>
			<tr>
				<td><b><u>PDF Element</u></b></td>
				<td><b><u>Present?</u></b></td>
			</tr>
			<tr>
				<td><b>Embedded Files</b></td>
				<xsl:choose>
				<xsl:when test="count(./names/EmbeddedFiles) > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Form Fields</b></td>
				<xsl:choose>
				<xsl:when test="count(./AcroForms/fields) > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
		</tbody>
	</table>
	
	<!-- page elements -->
	<xsl:apply-templates select="page" />
</xsl:template>

<xsl:template match="page">
	<h3>Page #<xsl:value-of select="@id"/></h3>
	<table cols="5" width="600">
		<tbody>
			<tr>
				<td></td>
				<td><b>x</b></td>
				<td><b>y</b></td>
				<td><b>width</b></td>
				<td><b>height</b></td>
			</tr>
			<xsl:apply-templates select="boxes"/>
		</tbody>
	</table>
	<p/>
	<table cols="2" width="300">
		<tbody>
			<tr>
				<td><b><u>Page Element</u></b></td>
				<td><b><u>Present?</u></b></td>
			</tr>
			<tr>
				<td><b>Tiled Patterns</b></td>
				<xsl:choose>
				<xsl:when test="./patterns/@tiled > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Shading Patterns</b></td>
				<xsl:choose>
				<xsl:when test="./patterns/@shading > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Transparency</b></td>
				<xsl:choose>
				<xsl:when test="./transparency/@objects > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Hidden Text</b></td>
				<xsl:choose>
				<xsl:when test="./text/@hidden-text='true'">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>OPI</b></td>
				<xsl:choose>
				<xsl:when test="count(./opi) > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Annotations</b></td>
				<xsl:choose>
				<xsl:when test="count(./annots) > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
			<tr>
				<td><b>Actions</b></td>
				<xsl:choose>
				<xsl:when test="count(./actions) > 0">
					<td><span style="color:red"><xsl:value-of select="'true'"/></span></td>
				</xsl:when>
				<xsl:otherwise>
					<td><xsl:value-of select="'false'"/></td>
				</xsl:otherwise>
				</xsl:choose>
			</tr>
	</tbody>
	</table>
	<p></p>
	<xsl:apply-templates select="images" />
</xsl:template>

<xsl:template match="boxes">
	<xsl:apply-templates />
</xsl:template>
<xsl:template match="MediaBox | CropBox | BleedBox | TrimBox | ArtBox">
	<tr>
		<xsl:variable name="bw" select="./@width"/>
		<xsl:if test="$bw != 0">
			<td><b><xsl:value-of select="name()"/></b></td>
			<td><xsl:value-of select="./@x"/></td>
			<td><xsl:value-of select="./@y"/></td>
			<td><xsl:value-of select="./@width"/></td>
			<td><xsl:value-of select="./@height"/></td>
		</xsl:if>
	</tr>
</xsl:template>

<xsl:template match="colors">
	<h3>Colors</h3>
	<table cols="3" width="600">
		<tr>
			<td><b><u>Colorspace</u></b></td>
			<td><b><u>Alternate</u></b></td>
			<td><b><u>Name</u></b></td>
		</tr>
		<xsl:apply-templates />
	</table>
</xsl:template>
<xsl:template match="color">
	<tr>
		<td>
			<xsl:choose>
			<xsl:when test="@base!='Separation' and @base!='DeviceGray' and @base!='DeviceCMYK'">
				<span style="color:red"><xsl:value-of select="@base"/></span>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="@base"/>
			</xsl:otherwise>
			</xsl:choose>
		</td>
		<td><xsl:value-of select="@alt"/></td>
		<xsl:if test=".!=''">
			<td><xsl:value-of select="."/></td>
		</xsl:if>

		<xsl:apply-templates />
	</tr>
</xsl:template>
<xsl:template match="fonts">
  <TABLE BORDER="0" COLS="5">
  <TR>
    <TD WIDTH="300"><B>Name</B></TD>
    <TD WIDTH="80"><B>Type</B></TD>
    <TD WIDTH="90"><B>Embedded</B></TD>
    <TD WIDTH="90"><B>Subset</B></TD>
    <TD WIDTH="50"><B>Page References</B></TD>
    <xsl:apply-templates />
  </TR>
  </TABLE>
</xsl:template>

<xsl:template match="font">
  <TR>
    <TD><xsl:value-of select="./@name"/></TD>
    <TD><xsl:value-of select="./@type"/></TD>
    <xsl:choose>
			<xsl:when test="./@embedded='true'">
  					<TD><xsl:value-of select="'true'"/></TD>
			</xsl:when>
			<xsl:otherwise>
  					<TD><span style="color:red"><xsl:value-of select="'false'"/></span></TD>
			</xsl:otherwise>
		</xsl:choose>
    <TD><xsl:value-of select="./@subset"/></TD>
    <xsl:variable name="fontID" select="./@id"/>
    <TD><xsl:value-of select="count(../../page/fonts/font[@id=$fontID])"/></TD>
  </TR>
</xsl:template>
<xsl:template match="images">
  <TABLE BORDER="0" width="700" COLS="11">
  <TR>
    <TD><B>ID</B></TD>
    <TD><B>BPC</B></TD>
    <TD><B>Colorspace</B></TD>
    <TD><B>Filter</B></TD>
    <TD><B>Height</B></TD>
    <TD><B>Width</B></TD>
    <TD><B>x Res</B></TD>
    <TD><B>y Res</B></TD>
    <TD><B>x Scale</B></TD>
    <TD><B>y Scale</B></TD>
    <TD><B>Rotation</B></TD>
    <xsl:apply-templates />
  </TR>
  </TABLE>
</xsl:template>
<xsl:template match="image">
  <TR>
    <TD><xsl:value-of select="./@id"/></TD>
    <TD><xsl:value-of select="./@bpc"/></TD>
    <xsl:choose>
    	<xsl:when test="./@colorspace!=''">
    		<TD><xsl:value-of select="./@colorspace"/></TD>
   		</xsl:when>
    	<xsl:when test="./@mask!=''">
    		<TD><xsl:value-of select="'MASK'"/></TD>
   		</xsl:when>
   		<xsl:otherwise>
    		<TD><span style="color:red"><xsl:value-of select="'unknown'"/></span></TD>
   		</xsl:otherwise>
    </xsl:choose>
    <TD><xsl:value-of select="./@filter"/></TD>
    <TD><xsl:value-of select="./@height"/></TD>
    <TD><xsl:value-of select="./@width"/></TD>
    <xsl:choose>
    	<xsl:when test="100 >= round(./@xres)">
    		<TD><span style="color:red"><xsl:value-of select="round(./@xres)"/></span></TD>
    	</xsl:when>
    	<xsl:otherwise>
    		<TD><xsl:value-of select="round(./@xres)"/></TD>
    	</xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
    	<xsl:when test="100 >= round(./@yres)">
    		<TD><span style="color:red"><xsl:value-of select="round(./@yres)"/></span></TD>
    	</xsl:when>
    	<xsl:otherwise>
    		<TD><xsl:value-of select="round(./@yres)"/></TD>
    	</xsl:otherwise>
    </xsl:choose>
   	<xsl:if test="./@xscale!=''">
    	<TD><xsl:value-of select="round(./@xscale)"/></TD>
    </xsl:if>
   	<xsl:if test="./@yscale!=''">
	    <TD><xsl:value-of select="round(./@yscale)"/></TD>
    </xsl:if>
    <TD><xsl:value-of select="./@rotation"/></TD>
  </TR>
</xsl:template>

</xsl:stylesheet>